#include <stdio.h>
#include <conio.h>

// vastavalt opssteemile defineerime kas WIN vi UNIX
#define WIN

enum LabyrinthElement {leEmpty, lePlayer, leWall, leTreasure};

struct Pos{
  int X;
  int Y;
};

const true = -1;
const false = 0;

const LabWidth = 10;
const LabHeight = 10;
int Lab[10][10];

char *FileName[10];
struct Pos PlayerPos;
int BlindGame=0;
int FileCount=0;
int CurrentFile=0;


/* Puhastab ekraani, kasutades selleks ssteemset ksku - 
   mistttu vajalikud ka vastavad direktiivid */
void ClearScreen(void){
  #ifdef UNIX
  system("clear");
  #else
  system("cls");
  #endif
  return;
}


int AnalyzeParameters(int argc, char *argv[]){
  int i;
  for(i=1;i<argc;i++){
    if(argv[i][0]=='-'){
      if(argv[i][1]=='b'){
        BlindGame=true;
      }
    }else{
      FileName[FileCount] = argv[i];
      FileCount++;
    }
  }
  return true;
}

// laeb andmed failist massiivi
int LoadGame(){
  int i,linecount=0,j;
  int Player=false, Treasure=false;
  char rida[128];
  FILE *sisend = fopen(FileName[CurrentFile], "r");

  for(i=0;i<LabHeight;i++){
    fgets(rida, 128, sisend);
    for(j=0;j<LabWidth;j++){
      switch(rida[j]){
        case ' ': Lab[i][j]=leEmpty; 
        break;
        case '+': Lab[i][j]=lePlayer; PlayerPos.X = j; PlayerPos.Y = i; Player=true;
        break;
        case 'O': Lab[i][j]=leWall; 
        break;
        case 'a': Lab[i][j]=leTreasure; Treasure = true;
        break;
        default: fclose(sisend); return false;
      }
    }  
  }
  fclose(sisend);
  if(Treasure && Player){
    return true;
  }else {
    return false;
  }
}

// joonistab hetkeseisu ekraanile
void ShowStandings(){
  int i,j;

  for(i=0;i<12;i++){
    printf("##");
  }
  printf("\n");

  for(i=0;i<10;i++){
    printf("##");
    for(j=0;j<10;j++){
      switch(Lab[i][j]){
        case leEmpty: printf("  "); 
        break;
        case lePlayer: printf("<>");
        break;
        case leWall: printf("##");
        break;
        case leTreasure: printf("><");
        break;
      }
    }  
    printf("##");
    printf("\n");
  }

  for(i=0;i<12;i++){
    printf("##");
  }
  printf("\n");

  return;
}

// Proovib kiku sooritada
// kui kik on korrektne, siis sooritab kigu ja tagastab leEmpty
// kui kiguga juti aardeni, siis tagastab leTreasure
// kui prkuti vastu seina, siis tagastab leWall
int PlayerMove(int dX, int dY){
  if(PlayerPos.X+dX>=0 && PlayerPos.X+dX<LabWidth &&
     PlayerPos.Y+dY>=0 && PlayerPos.Y+dY<LabHeight && 
     Lab[PlayerPos.Y+dY][PlayerPos.X+dX]!=leWall){
     //system("pause");
    if(Lab[PlayerPos.Y+dY][PlayerPos.X+dX]==leTreasure){
      return leTreasure;
    }
    Lab[PlayerPos.Y][PlayerPos.X] = leEmpty;
    Lab[PlayerPos.Y+dY][PlayerPos.X+dX] = lePlayer;
    PlayerPos.Y = PlayerPos.Y+dY;
    PlayerPos.X = PlayerPos.X+dX;
    return leEmpty;
  }else{
    return leWall;
  }
}

char KeyboardInput(void){
  return getch();
}

void DisplayWrongKeyErrorMessage(char Key){
  printf("Klahv %c pole kasutusel!", Key);
}

int PickNextFile(void){
  if(CurrentFile+1<FileCount){
    CurrentFile++;
    if(LoadGame()){
      ClearScreen();
      ShowStandings();
    }else{
      printf("Vigane Fail!");
      return false;
    }  
  }else{
    return false;
  }
}

int TranslateResult(int Result){
  switch(Result){
    case leEmpty: if(BlindGame)printf("Edukas kik\n");
    break;
    case leWall: printf("Prkasid vastu seina!\n");
    break;
    case leTreasure: printf("Leidsid aarde!!!\n"); 
                     system("pause");
                     return true;
    break;
  }
  return false;
}

int MainLoop(void){
  char Key;
  int Result;
  do {
    if(!BlindGame){
      // puhastame ekraani
      ClearScreen();
      // joonistame seisu ekraanile
      ShowStandings();
    }
    
    if(TranslateResult(Result)){
      if(!PickNextFile()){
        return true;
      }
    }
    
    // sisend klaviatuurilt
    Key=KeyboardInput();

    // tegevuse valik vastavalt nupuvajutusele
    switch(Key){
      case 'w': Result = PlayerMove( 0,-1);
      break;
      case 's': Result = PlayerMove( 0, 1);
      break;
      case 'a': Result = PlayerMove(-1, 0);
      break;
      case 'd': Result = PlayerMove( 1, 0);
      break;
      case 'q': return true;
      break;
      default: DisplayWrongKeyErrorMessage(Key);
    }
  }while(true);
}

int main(int argc, char *argv[]){
  AnalyzeParameters(argc, argv);
  
  if(LoadGame()){
    MainLoop();
  }else{
    printf("Vigane Fail!");
  }  

  return 0;
}

















