/// Characters on keys. First index is key nr and second index shows us the key.
string chars_on_telkey[10][5] =
{
  {"-","o","-","-","-"}, // klahv 0
  {"-","1","-","-","-"}, // klahv 1 jne
  {"-","a","b","c","-"},
  {"-","d","e","f","-"}, //3
  {"-","g","h","i","-"},
  {"-","j","k","l","-"}, // 5
  {"-","m","n","o","-"},
  {"-","p","q","r","s"}, //7
  {"-","t","u","v","-"},
  {"-","w","x","y","z"}  // 9
}; 

void generate_charstring_from_telnr (string telNr[]);
  void insert_array_indexes_to_charstring (string telNr[]);
    int is_valid_array_index (string telNr, string array_index);
    int max_strings (string str);
    // muudab ainult yhekohalist numbrit
    // ei leidnud vajalikku funktsiooni selle jaoks
    int one_string_to_int (string str);
    int string_to_int (string str);
    string itos(int i);	// convert int to string
    int min_strings (string str);
  void replace_array_indexes_in_charstring_with_chars (string telNr[]);
string ctos (char chr[]);            // changes char to string and removes last char,
void filter_junk (string telNr[]);   //                    line break, in this program
void writeout (string telNr[]);

void generate_charstring_from_telnr (string telNr[])
{
  int strLen = telNr[0].length();
  int i;
  
  insert_array_indexes_to_charstring (telNr);
  replace_array_indexes_in_charstring_with_chars (telNr);
}

/// Simply replaces chars in string with 4'rs.
/** So if the input is 123, output is 444. That's the max count of different
  * strings we can generate.
  */
int max_strings (string str)
{
  int str_len = str.size();
  int i;
  int max_strings=0;
  
  if (str_len>0)
    max_strings=4;
  
  for (i=0;i<str_len-1;i++)
  {
    max_strings=max_strings*10+4;
  }
  return max_strings;
}

/// Simply replaces chars in string with 1'es.
/** So if the input is 123, output is 111. That's the min count of different
  * strings we can generate.
  */
int min_strings (string str)
{
  int str_len = str.size();
  int i;
  int min_strings=0;
  
  if (str_len>0)
    min_strings=1;
  
  for (i=0;i<str_len-1;i++)
  {
    min_strings=min_strings*10+1;
  }
  return min_strings;
}

/// Check if we can gerate string from integer.
/** So what do I mean with integer? It's a special string filled with numbers.
  * Each of these tell which character to choose from a key.
  *
  * Which characters are on what key are stored in array chars_on_telkey.
  */
int is_valid_array_index (string telNr, string array_index)
{
  int str_len = telNr.size();
  int key;
  int chr;
  int i;
  /*
  if (telNr.size() != array_index.size() )
    return false;*/
  
  for (i=0;i<str_len;i++)
  {
    key = string_to_int( telNr.substr(i, 1)  );
    chr = string_to_int (array_index.substr(i,1));
    
    if ( chr<5) // massiivi piiridest ei saa kaugemale vaadata
      if (chars_on_telkey[key][chr] == "-")
        return false;
    if (chr>4)
      return false;
  }
  return true;
}

/// Converts string to integer.
/** Don't confuse this one with function that changes string type char to
  * integer.
  */
int string_to_int (string str)
{
  int output;
  
	istringstream sin(str);
	sin >> output;
  
	return output;
}

/// Convert integer to string.
/** Not char type string. */
string itos(int i)
{
 stringstream s;
 s << i;
 return s.str();
}

/// Generates all possible key indexes and inserts them into telNr.
/** So what do I mean by key index? On key 2 we have chars a, b anc c.
  * Key index is alias to every char and they start from 1 on every key.
  * So 1 = a, 2 = b and 3 = c.
  * "1221" was a great band.
  */
void insert_array_indexes_to_charstring (string telNr[])
{
  long unsigned int max_string = max_strings(telNr[0]);
  long unsigned int min_string = min_strings(telNr[0]);
  register long unsigned int i, k=1;
  
  for (i=min_string;i<max_string;i++)
  {
    if ( is_valid_array_index (telNr[0], itos(i) ) == true )
      telNr[k++] = itos(i);
  }
}

/// Looks up a character from key.
/** todo. Maby parameters should be integers.
  */
string array_index_to_char (string key, string array_index)
{
  int key_max = 10, array_index_max = 5; //  max array size (chars_on_telkey[10][5])
  int iKey = string_to_int (key);
  int iArrayIndex = string_to_int (array_index);

  if (iKey < key_max &&
      iArrayIndex < array_index_max
      )
  {
    return chars_on_telkey[iKey][iArrayIndex];
  }
  return "error";
}

/// Looks up a character from key.
/*  Del later. Made another function that's shorter and makes program more flexible.
string array_index_to_char (string key, string array_index)
{
  if (key=="0")
    if (array_index=="1")
      return "o";
  if (key=="1")
    if (array_index=="1")
      return "1";
  if (key=="2")
  {
    if (array_index=="1")
      return "a";
    if (array_index=="2")
      return "b";
    if (array_index=="3")
      return "c";
  }
  if (key=="3")
  {
    if (array_index=="1")
      return "d";
    if (array_index=="2")
      return "e";
    if (array_index=="3")
      return "f";
  }
  if (key=="4")
  {
    if (array_index=="1")
      return "g";
    if (array_index=="2")
      return "h";
    if (array_index=="3")
      return "i";
  }
  if (key=="5")
  {
    if (array_index=="1")
      return "j";
    if (array_index=="2")
      return "k";
    if (array_index=="3")
      return "l";
  }
  if (key=="6")
  {
    if (array_index=="1")
      return "m";
    if (array_index=="2")
      return "n";
    if (array_index=="3")
      return "o";
  }
  if (key=="7")
  {
    if (array_index=="1")
      return "p";
    if (array_index=="2")
      return "q";
    if (array_index=="3")
      return "r";
    if (array_index=="4")
      return "s";

  }
  if (key=="8")
  {
    if (array_index=="1")
      return "t";
    if (array_index=="2")
      return "u";
    if (array_index=="3")
      return "v";
  }
  if (key=="9")
  {
    if (array_index=="1")
      return "w";
    if (array_index=="2")
      return "x";
    if (array_index=="3")
      return "y";
    if (array_index=="4")
      return "z";
  }
  return "error";
}*/

/// Replaces numbers in array_index strings with characters.
/** Very important function.
  * From a previous examp., if we have a telephone nr 2222 and array_index string
  * 1221 the answer would be abba.
  */
void replace_array_indexes_in_charstring_with_chars (string telNr[])
{
  int str_len = telNr[0].size();
  string key, array_index;
  string temp;
  int i, k;

  i=1;
  while (telNr[i].size()!=0)
  {
    temp = "";
    for(k=0;k<str_len;k++)
    {
      key=telNr[0].substr(k, 1);
      array_index=telNr[i].substr(k, 1);
    
      temp = temp+ array_index_to_char(key, array_index);
    }
    telNr[i] = temp;
    i++;
  }
}

/// Character type string to string.
string ctos (char chr[])
{
  stringstream s;
  int strLen;
  
  s << chr;
  
  strLen = s.str().size();
  
  return s.str().substr(0, strLen-1);
}

/// Removes random strings with the help of dictionary.
/** Goes through the array telNr and removes all strings that doesn't exist in
  * words.txt.
  */
void filter_junk (string telNr[])
{
  char rida[256];
  int find;
  string word;
  int i = 0, k=0, l=0;
  string temp[70000];
  
  // let's open the dictionary and filter junk in our array of strings 
  while (telNr[i].size()!=0)
  {
    l=0;
    char rida[256];
    FILE *sisse=fopen("words.txt", "r");
    while(!feof(sisse))
    {
      fgets(rida, 256, sisse);
      find = telNr[i].find( ctos(rida) );
      
      if (find != -1)
        temp[k++] = telNr[i] + " " + ctos(rida);
      l++;
      
    }
    fclose(sisse);
    i++;
    
  }
  
  // now the strings that have some kind of a word in it are in temp
  
  // let's overwrite telNr
  
  i=0;
  while (telNr[i].size()!=0)
  {
    telNr[i+1] = temp[i];
    i++;
  }
  
}

/// Changes variable from string to char.
void stoc (string input, char output[])
{

  int i;  
  int strLen = input.size();
  char temp;
  
  for (i=0;i<strLen;i++)
  {
    temp = input[i];
    output[i] = temp;
  }
  output[i] = '\0';
}

/// Writes out array telNr.
void writeout (string telNr[])
{
  int i=0;
  char temp[128];

  FILE *valja=fopen("result.txt", "w");
  while (telNr[i].size()!=0)
  {
    stoc (telNr[i], temp);
    fprintf(valja, temp);
    fprintf(valja, "\n");
    i++;
  }
  fclose(valja);
}
